### Method

# Gck Slot open_session_full

#### Declaration [src]

    GckSession*
    gck_slot_open_session_full (
      GckSlot* self,
      GckSessionOptions options,
      gulong pkcs11_flags,
      gpointer app_data,
      CK_NOTIFY notify,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Open a session on the slot. If the ‘auto reuse’ setting is set, then this may be a recycled session with the same flags.

This call may block for an indefinite period.

This method is not directly available to language bindings.

#### Parameters

`options`

  Type: `GckSessionOptions`

  The options to open the new session with.

`pkcs11_flags`

  Type: `gulong`

  Additional raw PKCS#11 flags.

`app_data`

  Type: `gpointer`

  Application data for notification callback.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`notify`

  Type: `CK_NOTIFY`

  PKCS#11 notification callback.

`cancellable`

  Type: `GCancellable`

  Optional cancellation object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GckSession`

A new session or `NULL` if an error occurs.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.